<?php

class DetalleRepuestoModel {
    private $pdo;

    public function __construct()
    {
        try {
            require_once 'model/database.php';
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Buscar($Equipo_Id) {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL equipo_repuestos_buscar(?)");
            $stm->execute([$Equipo_Id]);
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r):
                $equipoRepuesto = new EquipoRepuesto();
                $equipoRepuesto->__set('nEquipo_Id', $r->nEquipo_Id);
                $equipoRepuesto->__set('nRepuesto_Id', $r->nRepuesto_Id);
                $equipoRepuesto->__set('sRepNombre', $r->sRepNombre);
                $equipoRepuesto->__set('sRepCodigo', $r->sRepCodigo);
                $result[] = $equipoRepuesto;
            endforeach;
            return $result;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function EliminarByEquipo($Equipo_Id) {
        try {
            $stm = $this->pdo->prepare("CALL equipo_repuestos_eliminar($Equipo_Id)");
            $stm->execute();
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }
}