<?php

require_once 'model/inspecciones.entidad.php';
require_once 'model/inspecciones.model.php';
require_once 'model/parametro.model.php';
require_once 'model/parametro.entidad.php';
require_once 'model/sistema.entidad.php';
require_once 'model/inspecciones_det.entidad.php';
require_once 'model/clientes.entidad.php';
require_once 'model/clientes.model.php';

class InspeccionesController extends helpers {

    private $inspecciones_model;
    private $parametro_model;
    private $clientes_model;

    public function __CONSTRUCT() {
        $this->inspecciones_model = new InspeccionesModel();
        $this->parametro_model = new ParametroModel();
        $this->clientes_model = new ClientesModel();
    }

    public function Index() {
        $parametro = $this->parametro_model->ListarParametros();
        $inspecciones = $this->inspecciones_model->Listar_Date(
            isset($_POST['fechaInicio']) ? $_POST['fechaInicio'] : date('d-m-Y', strtotime('-1 day', strtotime(date('d-m-Y')))),
            isset($_POST['fechaFin']) ? $_POST['fechaFin'] : date('d-m-Y', strtotime(date('d-m-Y'))));

        require_once 'view/header.php';
        require_once 'view/webforms/wfainspecciones.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.operaciones').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }
  
    public function IndexCli() {
        //print_r($_SESSION);
        $parametro = $this->parametro_model->ListarParametros();
		// anterior
        //$cliente = $this->clientes_model->Buscar($_SESSION['usu_codigo']);
		
		$cliente = $this->clientes_model->Buscar($_SESSION['usu_Cli_Id']);
        $cliente = $cliente[0];
		/*
		var_dump($_SESSION['usu_codigo']);  //1
		var_dump($cliente->sCliCodigo);  //010101	
		var_dump($cliente->Cliente_Id);  //1
		
		return;
		*/	
        $inspecciones = $this->inspecciones_model->ListarDeClienteDate(
            $cliente->sCliCodigo,
            isset($_POST['fechaInicio']) ? $_POST['fechaInicio'] : date('d-m-Y', strtotime('-1 day', strtotime(date('d-m-Y')))),
            isset($_POST['fechaFin']) ? $_POST['fechaFin'] : date('d-m-Y', strtotime(date('d-m-Y')))
        );
        require_once 'view/headercliente.php';
        require_once 'view/webforms/wfainspeccionesc.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.operaciones').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function PDF(){
        $datos = $this->inspecciones_model->Buscar($_GET['Inspeccion_Id']);
        $sistemas = $this->inspecciones_model->ListarSistemas();
        $detalle1  = $this->inspecciones_model->ListarDetalle1($_GET['Inspeccion_Id']);
        $detalle2  = $this->inspecciones_model->ListarDetalle2($_GET['Inspeccion_Id']);
        $detalle2diodos  = $this->inspecciones_model->ListarDetalle2Diodos($_GET['Inspeccion_Id']);
        $detalle3  = $this->inspecciones_model->ListarDetalle3($_GET['Inspeccion_Id']);
        $detalle3detalle  = $this->inspecciones_model->ListarDetalle3detalle($_GET['Inspeccion_Id']);
        $preguntas  = $this->inspecciones_model->ListarPreguntas();
       
        //print_r($_GET['Inspeccion_Id']);
        //print_r($detalle3);
        require_once 'view/webforms/PDF/pdfinspeccion.php';
        
    }
	
	public function buscarCertificado(){
			$cert  = (json_encode($this->inspecciones_model->validaCert($_POST['Inspeccion_Id'])));
			//var_dump($cert);
			echo $cert ;
	}
	/* crea certificado */
	public function PDFcertificadoCrear(){
	 //$input = substr($_POST['dAteFechaHoraI'], 0,  11) . substr($_POST['dAteFechaHoraI'], 11,  8);
        
        //$reclamos->__SET('dAteFechaHoraI', date('Y-m-d H:i:s', strtotime($input))); 
        //$input = substr($_POST['dAteFechaHoraF'], 0,  11) . substr($_POST['dAteFechaHoraF'], 13,  8);
        //$reclamos->__SET('dAteFechaHoraF',   date('Y-m-d H:i:s', strtotime($input)));}}};

        $re =  date('Y-m-d', strtotime($_GET['dRecFecha'])); 
		//var_dump($re);
		//var_dump($_SESSION['usu_codigo']);
		
        $datos = $this->inspecciones_model->Buscar($_GET['Inspeccion_Id']);

		 $cert  = $this->inspecciones_model->validaCert($_GET['Inspeccion_Id']);
		 if (count($cert) > 0 ){
					//existe 
					require_once 'view/webforms/PDF/pdfcertificado.php';
		 }else{
				if ($_SESSION['usu_tipo'] == 3){
					$certif  = json_decode(json_encode($this->inspecciones_model->buscarLastCert($_GET['Inspeccion_Id'])));			
					foreach ($certif as $value) {
						$num = str_pad((intval($value->id)+1), 6, "0", STR_PAD_LEFT);
						//$reclamos->__SET('sAteNumero', $value->sSerie .$num);
						
						$cert  =  $this->inspecciones_model->crearCert($_GET['Inspeccion_Id'], $num, $re, $_SESSION['usu_codigo'], $_GET['sAteTipo'] );
						$cert  = $this->inspecciones_model->validaCert($_GET['Inspeccion_Id']);
						require_once 'view/webforms/PDF/pdfcertificado.php';
					}
				}else{
					
				}
		}		
        
    }
	
	public function CertPorVencer(){
				//if ($_SESSION['usu_tipo'] != 2){
				$parametro = $this->parametro_model->ListarParametros();
				$param = $parametro[1];
				$param = intval($param->sParValor);
				
				$certif  = json_decode(json_encode($this->inspecciones_model->CertPorVencer()));	
				//$certif  = $this->inspecciones_model->CertPorVencer();	

				if ($_SESSION['usu_tipo'] == 2) { /*em 26-01-25 */
					 $cliente = $this->clientes_model->Buscar($_SESSION['usu_Cli_Id']);
					$cliente = $cliente[0];
					$certif  = json_decode(json_encode($this->inspecciones_model->CertificadosxvencerCli($cliente->sCliCodigo)));
				}	
				$hoy = date("Y-m-d"); 
					$array = [];
					foreach ($certif as $r) {
						$fin =  date('Y-m-d', strtotime($r->dInsFechaVencimiento)); 
						$inicio =  date('Y-m-d', strtotime($fin."- $param days")); 
						
							if ( $hoy >= $inicio   &&  $hoy <= $fin ){
							$array[] = array(
							    'id' => $r->id,
								'Inspeccion_Id' => $r->Inspeccion_Id,
								'sInsCerCorrelativo' => $r->sInsCerCorrelativo,
								'dInsFechaVencimiento' => $r->dInsFechaVencimiento
							);
						}	
					}
					print_r(json_encode($array));
				//}
	}	


public function aprobarCertificado(){
	
        $datos = $this->inspecciones_model->aprobarCertificado($_POST['Inspeccion_Id']);
}	
/*------------------------------------------------------------------------------------------------------------------*/
    public function EliminarInspeccion() {
        //print_r($_POST['Inspeccion_Id']);

        $this->inspecciones_model->EliminarInspeccion($_POST['Inspeccion_Id']);
        echo '<script type="text/javascript">window.location="?c=Inspecciones&a=Index";</script>';
    }

        public function FrmEditarDetalles()
    {
        $Inspeccion_Id = $_POST["Inspeccion_Id"];
        $datos = $this->inspecciones_model->Buscar($Inspeccion_Id);
        $sistemas = $this->inspecciones_model->ListarSistemas();
        $detalle1 = $this->inspecciones_model->ListarDetalle1($Inspeccion_Id);
        $detalle2 = $this->inspecciones_model->ListarDetalle2($Inspeccion_Id);
        $detalle2diodos = $this->inspecciones_model->ListarDetalle2Diodos($Inspeccion_Id);
        $detalle3 = $this->inspecciones_model->ListarDetalle3($Inspeccion_Id);
        $detalle3detalle = $this->inspecciones_model->ListarDetalle3detalle($Inspeccion_Id);
        $preguntas = $this->inspecciones_model->ListarPreguntas();
        //$r = [];

        //print_r($_GET['Inspeccion_Id']);
        //print_r($detalle3);
        require_once 'view/webforms/wfainspeccionesb.php';
    }

    public function GuardarEdicion_Datos()
    {
        $cabecera = json_decode($_POST['jcabecera']);
        $respuesta = $this->inspecciones_model->GuardarEdicion_Datos($cabecera);
        echo $respuesta;
    }

    public function GuardarEdicion_EvMecanica()
    {
        $evmecanica = json_decode($_POST["jEvMecanica"]);
        $respuesta = $this->inspecciones_model->GuardarEdicion_EvMecanica($evmecanica);
        echo $respuesta;
    }

    public function GuardarEdicion_EvElectrica()
    {
        $evelectrica = json_decode($_POST["jEvElectrica"]);
        $respuesta = $this->inspecciones_model->GuardarEdicion_EvElectrica($evelectrica);
        echo $respuesta;
    }

    public function GuardarEdicion_EvDiodos()
    {
        $evdiodos = json_decode($_POST["jEvDiodos"]);
        $respuesta = $this->inspecciones_model->GuardarEdicion_EvDiodos($evdiodos);
        echo $respuesta;
    }

    public function GuardarEdicion_PruebaConCarga()
    {
        $pruebaconcarga = json_decode($_POST["jPruebaConCarga"]);
        $respuesta = $this->inspecciones_model->GuardarEdicion_PruebaConCarga($pruebaconcarga);
        echo $respuesta;
    }


///////////////////////////////////////////////////////

    public function IndexUsuarioApp() {
        $parametro = $this->parametro_model->ListarParametros();
        $usuarios = $this->usuario_model->ListarUsuariosApp();
        require_once 'view/header.php';
        require_once 'view/webforms/wfausuarioapp.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.catalogos').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }
    

    public function FrmNuevoUsu() {
        $parametro = $this->parametro_model->ListarParametros();
        $usuarios = $this->usuario_model->Listar();
        require_once 'view/header.php';
        require_once 'view/webforms/wfausuarioa.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.catalogos').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function FrmGuardarUsuario() {
        require_once 'view/webforms/wfausuarioa.php';
    }

    public function FrmEditarUsuario() {
        $obtenerUsuario = $this->usuario_model->Buscar($_POST['Usuario_Id']);
        foreach ($obtenerUsuario as $r):
            require_once 'view/webforms/wfausuarioa.php';
        endforeach;
    }

    public function MostrarUsuario() {
        $usuarios = $this->usuario_model->Buscar($_POST['Usuario_Id']);
        foreach ($usuarios as $r):
            if ($r->__GET('nUsuTipo') == 1) {
                $tipo = "ADMINISTRADOR";
            } elseif ($r->__GET('nUsuTipo') == 2) {
                $tipo = "SUPERVISOR PRODUCCION";
            } elseif ($r->__GET('nUsuTipo') == 3) {
                $tipo = "CALIDAD";
            } elseif ($r->__GET('nUsuTipo') == 4) {
                $tipo = "OPERARIO";
            } elseif ($r->__GET('nUsuTipo') == 10) {
                $tipo = "SUPERVISOR CALIDAD";
            } elseif ($r->__GET('nUsuTipo') == 11) {
                $tipo = "POST VENTA";
            } else {
                $tipo = "NA";
            }

            echo " <tbody>
                          <tr>
                             <td>
                                <input type='hidden' name='idUsuario' id='idUsuario' value='" . $r->__GET('Usuario_Id') . "'> 
                                Nombre de Usuario
                             </td>
                             <td>" . $r->__GET('sUsuNombre') . "</td>
                          </tr>
                          <tr>
                             <td>Login</td>
                             <td>" . $r->__GET('sUsuLogin') . "</td>
                          </tr>  
                          <tr>
                             <td>Tipo de Usuario</td>
                             <td>" . $tipo . "</td>
                          </tr>  
                          <tr>
                             <td>Estado</td>
                             <td>" . ($r->__GET('nUsuEstado') == '1' ? '<span class="label bg-green">Habilitado</span>' : '<span class="label bg-danger">Inhabilitado</span>') . "</td>
                          </tr>
                       </tbody>
                     ";
        endforeach;
    }

    public function GuardarUsuario() {
        $usu = new Usuario();
        if ($_POST['idRegistro'] != 0 ? $usu->__SET('Usuario_Id', $_POST['idRegistro']) : '');
        $usu->__SET('Personal_Id', $this->str_uppercase($_POST['Personal_Id']));
        $usu->__SET('sUsuNombre', $this->str_uppercase($_POST['nombre']));
        $usu->__SET('sUsuLogin', $this->str_uppercase($_POST['login']));
        $usu->__SET('sUsuContrasena', $this->str_uppercase($_POST['contraseñaTwo']));
        $usu->__SET('nUsuTipo', $this->str_uppercase($_POST['tipo']));
        $usu->__SET('nUsuEstado', $this->str_uppercase($_POST['estado']));
        $usu->__SET('sUsuCodigosap', $_POST["codigosap"]);
        $usu->__SET('nUsuEliminado', 0);
        $usu->__SET('nUsuUsuarioOwn_Id', $_SESSION['usu_codigo']);
        if ($_POST['idRegistro'] == 0 ? $this->usuario_model->Guardar($usu) : $this->usuario_model->Editar($usu));
    }


    public function PDFUsuario() {
        $datos = $this->usuario_model->Buscar($_POST['idUsuario']);
        require_once 'view/webforms/PDF/usuario.php';
    }
	
	/*em 12-01-20 */
	public function AceptarInspeccion() {
        $this->inspecciones_model->AceptarInspeccion($_POST['Inspeccion_Id'], $_POST['valora']);
        echo '<script type="text/javascript">window.location="?c=Inspecciones&a=IndexCli";</script>';
    }
	/*--------------------------------------------------------------------------------------------------------------*/
	/*                                 SOAP                                   */
	/*em 17-11-2020 */
	 public function buscarCodigoSoap(){
         
            $soap = new SoapX();

            //RETORNO DE DATOS XML
            //$soap->getCliente($_POST["client_id"]);
            //$soap->getEquipo('10034647','V');
            //  0001001054
            
            //IMPRESION DE DATOS XML
            //return json_decode(json_encode($soap->printCliente($_POST["client_id"])));
			return $soap->printCliente($_POST["client_id"]);
         }
	public function buscarVinSoap(){
         
            $soap = new SoapX();

            //RETORNO DE DATOS XML
            //$soap->getCliente($_POST["client_id"]);
            //$soap->getEquipo('10034647','V');
            
            //IMPRESION DE DATOS XML
            return $soap->printEquipo($_POST["client_id"],'V');
     }
	  /*em 17-11-2020 */
          public function buscarCodigoSoapByDoc(){       
            $soap = new SoapX();
            return $soap->printClienteByDoc($_POST["client_id"]);
         }
         /*em 17-11-2020 */
         public function buscarCodigoSoapByName(){       
            $soap = new SoapX();
            return $soap->printClientesByName($_POST["client_id"]);
         }
		 public function buscarCodigoSoapByEquipo(){       
            $soap = new SoapX();
            return $soap->printEquipo($_POST["client_id"]);
         }
		 /* EM 23-11-2020 */
		 public function buscarCodigoSoapByEquipoByClient(){       
            $soap = new SoapX();
            return $soap->printEquipoByClient($_POST["client_id"], "V");
         }
}

?>