<?php

class ProgramaciónModel {
    private $pdo;

    public function __construct()
    {
        try {
            require_once 'model/database.php';
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Listar() {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL programacion_listar(0)");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r):
                $programacion = new Programación();
                $programacion->__SET('Programacion_Id', $r->Programacion_Id);
                $programacion->__SET('dProFecha', $r->dProFecha);
                $programacion->__SET('nProEquipo_Id', $r->nProEquipo_Id);
                $programacion->__SET('nProEquipo_Id', $r->nProEquipo_Id);
                $programacion->__SET('nProTecnico_Id', $r->nProTecnico_Id);
                $programacion->__SET('nProPlantilla_Id', $r->nProPlantilla_Id);
                $programacion->__SET('dProFecha_Act', $r->dProFecha_Act);
                $programacion->__SET('nProUsuario_Id', $r->nProUsuario_Id);
                $programacion->__SET('nProEstado', $r->nProEstado);
                $programacion->__SET('nProEliminado', $r->nProEliminado);
                $programacion->__SET('sEqActivoFijo', $r->sEqActivoFijo);
                $programacion->__SET('sUsuNombre', $r->sUsuNombre);
                $programacion->__SET('sPlaNombre', $r->sPlaNombre);
                $result[] = $programacion;
            endforeach;
            return $result;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Buscar($Programacion_Id) {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL programacion_listar($Programacion_Id)");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r):
                $programacion = new Programación();
                $programacion->__SET('Programacion_Id', $r->Programacion_Id);
                $programacion->__SET('dProFecha', $r->dProFecha);
                $programacion->__SET('nProEquipo_Id', $r->nProEquipo_Id);
                $programacion->__SET('nProEquipo_Id', $r->nProEquipo_Id);
                $programacion->__SET('nProTecnico_Id', $r->nProTecnico_Id);
                $programacion->__SET('nProPlantilla_Id', $r->nProPlantilla_Id);
                $programacion->__SET('dProFecha_Act', $r->dProFecha_Act);
                $programacion->__SET('nProUsuario_Id', $r->nProUsuario_Id);
                $programacion->__SET('nProEstado', $r->nProEstado);
                $programacion->__SET('nProEliminado', $r->nProEliminado);

                $programacion->__SET('sEqActivoFijo', $r->sEqActivoFijo);
                $programacion->__SET('sUsuNombre', $r->sUsuNombre);
                $programacion->__SET('sPlaNombre', $r->sPlaNombre);
                $result[] = $programacion;
            endforeach;
            return $result;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function ListTableMantenimiento()
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL list_table_progMantenimiento()");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r):
                $result[] = $r;
            endforeach;
            return $result;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function UltimoContratoxEquipo($CodigoEquipo) {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL ultimo_contratoXEquipo(?)");
            $stm->execute([$CodigoEquipo]);
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r):
                $result[] = $r;
            endforeach;
            return $result;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function UltimosMantenimientoXEquipo($Equipo_Id) {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL ultimos_MantXEquipo(?)");
            $stm->execute([$Equipo_Id]);
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r):
                $result[] = $r;
            endforeach;
            return $result;
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Guardar(Programación $programacion) {
        try {
            $stm = $this->pdo->prepare("CALL programacion_crear(?,?,?,?,?)");
            $stm->execute(array(
                $programacion->__GET('dProFecha'),
                $programacion->__GET('nProEquipo_Id'),
                $programacion->__GET('nProTecnico_Id'),
                $programacion->__GET('nProPlantilla_Id'),
                $programacion->__GET('nProUsuario_Id'),
            ));
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Editar(Programación $programacion) {
        try {
            $stm = $this->pdo->prepare("CALL programacion_editar(?,?,?,?,?,?)");
            $stm->execute(array(
                $programacion->__GET('dProFecha'),
                $programacion->__GET('nProEquipo_Id'),
                $programacion->__GET('nProTecnico_Id'),
                $programacion->__GET('nProPlantilla_Id'),
                $programacion->__GET('nProUsuario_Id'),
                $programacion->__GET('Programacion_Id'),
            ));
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Eliminar(Programación $programacion) {
        try {
            $stm = $this->pdo->prepare("CALL programacion_eliminar(?)");
            $stm->execute(array(
                $programacion->__GET('Programacion_Id')
            ));
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }
}