var myApp = (function (myApp, undefined) {
    var _ajaxDefault = {
            data: {},
            type: 'POST',
            async: false,
            dataType: "json",
            processData: true,
            parameters: [],
            callbackDone: undefined,
            callbackFail: undefined,
            callbackAlways: undefined,
            callbackProgress: undefined
        };
    myApp.dateDDMMYYYY = function(date, string){
        var splitDate = date.split(string);
        return splitDate[2] + '-' + splitDate[1] + '-' + splitDate[0];
    },
    
    myApp.DatosCliente = function(Cliente_Id){
          
        var data = {};
        
        $.ajax({
            url: '?c=Cliente&a=JsonDatosCliente',
            data: { "Cliente_Id" : Cliente_Id },
            type: 'POST',
            async: false,
            success: function(response){
                
                data = response;
            
            }
        });
        
        return JSON.parse(data);
        
    },
    
    myApp.ajax = function (options) {

        var options = $.extend({}, _ajaxDefault, options);

        $.ajax({
            type: options.type,
            url: options.url,
            async: options.async,
            data: options.data,
            dataType: options.dataType,
            contentType: options.contentType,
            processData: options.processData

        })
        .progress(function (data, textStatus, jqXHR) {

            if (options.callbackProgress != undefined)
                options.callbackProgress(data, textStatus, jqXHR);

        }).done(function (data, textStatus, jqXHR) {

            if (options.callbackDone != undefined)
                options.callbackDone(data, textStatus, jqXHR);

        }).fail(function (jqXHR, textStatus, errorThrown) {

            if (options.callbackFail != undefined)
                options.callbackFail(jqXHR, textStatus, errorThrown);

        }).always(function (data, textStatus, jqXHR) {

            if (options.callbackAlways != undefined)
                options.callbackAlways(data, textStatus, jqXHR);

        });

    };        

    return myApp;

})(myApp || {});

(function($) {
    $.fn.constantes = function(params) { 
        
        var settings = $.extend({
            
            nConCodigo: 0,
            value: '',
            Select: true,
            SelectText: '- seleccione -',
            SelectNom: true,
            
            onChangeConstantes: function(){ }
            
        }, params);
               
        var oData = {};
        
        oData.nConCodigo = settings.nConCodigo;

        myApp.ajax({
            
           url: "?c=Principal&a=ListarConstantes",
           data: oData,
           parameters: [$(this)],
           callbackDone: callbackDoneListarConstantes
           
        });        
        
        function callbackDoneListarConstantes(data){
            
            var oHtml = '', buttons = this.parameters[0];
            
            oHtml += settings.Select == true ? '<option value="">' + settings.SelectText + '</option>' : '';
            
            for(var i = 0; i< data.length;i++)
            {
            
                oHtml += data[i].nConEstado == 1 ? '<option value="' + ( settings.SelectNom == true ? data[i].nConValor : data[i].sConNombre ) + '" data-index="'+ i + '">' + data[i].sConNombre + '</option>' : '';                
                
            }
            
            buttons.html(oHtml);
            
            buttons.change(function (event) { settings.onChangeConstantes(data[parseInt(buttons.find('option:selected').data("index"))], buttons.val(), buttons, event); });
            
        }
    },
    
    $.fn.ATDmessage = function(options){
        
        var _typeMessage = {

                success: 'success',
                info: 'info',
                warning: 'warning',
                danger: 'danger'

            },
                    
            _messageDefault = {

                type: _typeMessage.success,
                icon: undefined,
                header: undefined,
                message: undefined,
                body: undefined,
                btnClose: true

            };
            
        var options = $.extend({}, _messageDefault, options);

        switch (options.type) {
            case 'success':
                options.icon = options.icon || 'fa-check';
                options.header = options.header || 'Éxito';
                options.message = options.message || 'Éxito';
                break;
            case 'info':
                options.icon = options.icon || 'fa-info';
                options.header = options.header || 'Información';
                options.message = options.message || 'Información';
                break;
            case 'warning':
                options.icon = options.icon || 'fa-warning';
                options.header = options.header || 'Alerta';
                options.message = options.message || 'Alerta';
                break;
            case 'danger':
                options.icon = options.icon || 'fa-times';
                options.header = options.header || 'Error';
                options.message = options.message || 'Error';
                break;
            default:
                break;
        }

        var elements = {

            container: '<div class="alert alert-block alert-' + options.type + '"></div>',
            btnClose: '<button type="button" class="close" data-dismiss="alert"><i class="ace-icon fa fa-times"></i></button>',
            message: '<p><strong><i class="ace-icon fa ' + options.icon + '"></i> ' + options.header + '! </strong>' + options.message + '.</p>',
            body: '<div class="widget-main">' + options.body + '</div>'

        };

        $(this).html($(elements.container).append(options.btnClose == true ? elements.btnClose : '').append(elements.message).append(options.body == undefined ? '' : elements.body));

    };
})(jQuery);